unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, StdCtrls, RobotUnit;

type

  { TForm1 }

  TForm1 = class(TForm)
    CheckBox1: TCheckBox;
    dlzkaKroku: TEdit;
    Label4: TLabel;
    suradnicaX: TEdit;
    suradnicaY: TEdit;
    uhol: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    uholDolava: TEdit;
    uholDoprava: TEdit;
    zavriet: TButton;
    kresli: TButton;
    nacitajSubor: TButton;
    Image1: TImage;
    OpenDialog1: TOpenDialog;
    procedure FormCreate(Sender: TObject);
    procedure kresliClick(Sender: TObject);
    procedure zavrietClick(Sender: TObject);
    procedure nacitajSuborClick(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 
  fileName: string;
implementation

{ TForm1 }


procedure TForm1.zavrietClick(Sender: TObject);
begin
  close;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  fileName:='SBot.txt';
end;

procedure TForm1.kresliClick(Sender: TObject);
var
  R: TRobot;
  f: textFile;
  znak: char;
  krok, uholLeft, uholRight : Real;
  X, Y, uholNatocenia, c1, c2, c3: integer;

procedure nastav(var L,R: real);      //////////////
var
  Robot: TRobot;
  min, angle: real;
  f: textFile;
  I: integer;
  znak: char;
begin
  min:=1000;
  for I:=50 to 80 do
  begin
    Robot:=TRobot.Create;
    AssignFile(f, fileName);
    Reset(f);
    while not eof(f) do
    begin
      read(f, znak);
      case znak of
        'F': Robot.Fd(0.1);
        'R': Robot.Rt(I/1000);
        'L': Robot.Lt(I/1000);
      end;
    end;

    if (Robot.Dist(image1.Width div 2,image1.Height div 2)<min) then
    begin
      min:=Robot.Dist(image1.Width div 2,image1.Height div 2);
      angle:=I/1000;
    end;
    Robot.Free;
    closeFile(f);
  end;

  suradnicaX.Text:=inttostr(image1.Width div 2);
  suradnicaY.Text:=inttostr(image1.height div 2);
  uholDolava.Text:=floattostr(angle);
  uholDoprava.Text:=floattostr(angle);
  uhol.text:='0';
  L:=angle;
  R:=angle;
end;    //////////
begin
  image1.Canvas.FillRect(image1.clientRect);

  val(suradnicaX.Text, X, c1);
  val(suradnicaY.Text, Y, c2);
  val(uhol.Text, uholNatocenia, c3);

  if ((c1=0) and (c2=0) and (c3=0)) then R:=TRobot.Create(X,Y,uholNatocenia)
  else R:= TRobot.create();
  R.PD;

  c1:=0;
  c2:=0;
  c3:=0;

  if checkBox1.Checked then
  begin
    val(dlzkaKroku.Text, krok, c1);
    val(uholDolava.Text, uholLeft, c2);
    val(uholDoprava.Text, uholRight, c3);
    AssignFile(f, fileName);
    Reset(f);
  end
  else
  begin
    nastav(uholLeft, uholRight);
    image1.Canvas.FillRect(image1.clientRect);
    krok:=0.1;
    AssignFile(f, fileName);
    Reset(f);
  end;

  if ((c1=0) and (c2=0) and (c3=0)) then
  while not eof(f) do
  begin
    read(f, znak);
    case znak of
      'F': R.Fd(krok);
      'R': R.Rt(uholRight);
      'L': R.Lt(uholLeft);
    end;
  end;

  CloseFile(f);
end;

procedure TForm1.nacitajSuborClick(Sender: TObject);
begin
   filename:='';
   if OpenDialog1.Execute then
   begin
     filename := OpenDialog1.Filename;
     ShowMessage(filename);
   end;
  if filename='' then fileName:='SBot.txt';
end;

initialization
  {$I unit1.lrs}

end.

