#include "main.h"


///////////////////////////////////////////////////////////////////////////////

#define SERVO1dopredu	2700
#define SERVO4dopredu	2860

#define SERVO1doprava	2700
#define SERVO4doprava	2550

#define SERVO1dolava	2960
#define SERVO4dolava	2860

char usek[1000];
int i;
int poc=0;

void dopredu(){
  set_servo(1, SERVO1dopredu); //lave
  set_servo(4, SERVO4dopredu);  // prave
  servo_123_on();
  servo_456_on();
} 

void dolava(){   
  set_servo(1, SERVO1dolava);
  set_servo(4, SERVO4dolava);
  servo_123_on();
  servo_456_on();}

void doprava(){
  set_servo(1, SERVO1doprava);
  set_servo(4, SERVO4doprava);
  servo_123_on();
  servo_456_on();
}

void stop(){
  servo_123_off();
  servo_456_off(); 
}

int prekazka(){   // nedokoncene////////////////////////////////////////////////////////////////////////////////////
  return 0;
}

int pravyCierna(){
	if (adc_vals[1]>900) { return 1;
	}else {return 0;}

}

int pravyBiela(){
	if (adc_vals[1]<900) { return 1;
	}else {return 0;}

}


int lavyCierna(){
	if (adc_vals[0]>900) { return 1;
	}else {return 0;}

}

int lavyBiela(){
	if (adc_vals[0]<900) { return 1;
	}else {return 0;}

}

void odosli(){
  int j;
  for (j=0; j<=1000; j++){
    printf("%c",usek[j]);
  } 
 
}

int jeNaCiare(){
  if ((pravyCierna()) || (lavyCierna())){return 0;}

  int pravyChytil = 0;
  int lavyChytil = 0;
  long time1, time2;

  stop();
  doprava();
  time1 = current_time;

  while ((!pravyChytil) && (!lavyChytil) && (current_time - time1 < 100)) {
	if (pravyCierna()) pravyChytil=1;
	if (lavyCierna()) lavyChytil=1;
  }
  time2 = current_time;
  stop();
  
  if ((pravyChytil)||(time2 - time1 >= 100)){
    dolava();
    time1 = current_time;
    while(current_time - time1 < 100){time2++;}
    stop();
    return 0;
  }
  if (lavyChytil){
    dolava();
	while (!pravyChytil){
	  if (pravyCierna()) pravyChytil=1;
	}
	stop();
	doprava();
	while(pravyCierna()){
	}
	if ((pravyBiela()) && (lavyBiela())) {
	  stop();
	  return 1;
	}
  }

}

void najdiCiaru(){
  int pravyChytil = 0;
  int lavyChytil = 0;

  dopredu();
  while ((!pravyChytil) && (!lavyChytil)){    
    if (pravyCierna()) pravyChytil=1;
	if (lavyCierna()) lavyChytil=1; 
  }
  stop();
  wait(200);
  if (pravyCierna()) pravyChytil=1;
  if (lavyCierna()) lavyChytil=1; 

  if (pravyChytil && lavyChytil){ //kolmo
    dopredu();
	wait(200);
	stop();
	doprava();
    while(pravyBiela()){};
    while(pravyCierna()){};
	stop();
  }

  if ((pravyChytil)&&(!lavyChytil)){
    dopredu();
	while(pravyCierna()){}
	stop();
	if(jeNaCiare()){}
	else{
	  doprava();
	  wait(100);
	  najdiCiaru();
	}
    
  }
  if ((!pravyChytil)&&(lavyChytil)){
    dopredu();
	while(lavyCierna()){}
	stop();
	if(jeNaCiare()){}
	else{
	  dolava();
	  wait(100);
	  najdiCiaru();
	}
  }
  
}

void drzCiaru(){
  int zaciatok=0;
  while (!prekazka()&&(!zaciatok)){
    int pravyChytil = 0;
    int lavyChytil = 0;
    dopredu();

    while ((!pravyChytil) && (!lavyChytil) && (!prekazka())){
      if (pravyCierna()) pravyChytil=1;
	  if (lavyCierna()) lavyChytil=1;
      
      if ((pravyCierna())&&(lavyCierna())) {
	    zaciatok=1;
		stop();
		break;
	  }

	  if (poc++==500){
	    if (i<1000) {
	      usek[i++]='F';
		  poc=0;
        }else{
	      stop();
  		  odosli();
		  i=0;
		  poc=0;
	  	  wait(100);
		  dopredu();
	    }  
      }
    }


    if ((pravyCierna())&&(lavyCierna())) {
	  zaciatok=1;
	  stop();
	  break;
	}
	if (prekazka()) { break;}
    if (pravyChytil) {
	  wait(50);
	  if ((pravyCierna())&&(lavyCierna())) {
	    zaciatok=1;
		stop();
		break;
	  } 
	  doprava();
	  while (pravyCierna()){
		if (poc++==500){
          if (i<1000) {
	      usek[i++]='R';
		  poc=0;
          }else{
	      stop();
	  	  odosli();
		  i=0;
		  poc=0;
		  wait(100);
		  doprava();
	      }
		}
	  }
	}

    if (lavyChytil) { 
	  wait(50);
	  if ((pravyCierna())&&(lavyCierna())) {
	    zaciatok=1;
		stop();
		break;
	  }

	  dolava();
	  while (lavyCierna()){
	    if (poc++==500){
          if (i<1000) {
	      usek[i++]='L';
		  poc=0;
          }else{
	      stop();
		  odosli();
		  i=0;
		  poc=0;
		  wait(100);
		  dolava();
	      }    
        }
	  }
	}
    dopredu();
  }
  odosli();
}

void najdiZaciatok(){
  int zaciatok=0;
  while (!zaciatok){
    int pravyChytil = 0;
    int lavyChytil = 0;
    dopredu();

    while ((!pravyChytil) && (!lavyChytil) && (!prekazka())){
      if (pravyCierna()) pravyChytil=1;
	  if (lavyCierna()) lavyChytil=1;
	    
	  if ((pravyCierna())&&(lavyCierna())) {
	    zaciatok=1;
		stop();
		break;
	  }
    }


	  
    if ((pravyCierna())&&(lavyCierna())) {
	  zaciatok=1;
	  stop();
	  break;
	}
	if (prekazka()) { break;}

    if (pravyChytil) { 
	  wait(50);
	  if ((pravyCierna())&&(lavyCierna())) {
	    zaciatok=1;
		stop();
		break;
	  }
	  doprava();
	  while (pravyCierna()){     
	  }
	}

    if (lavyChytil) { 
	  wait(50);
	  if ((pravyCierna())&&(lavyCierna())) {
	    zaciatok=1;
		stop();
		break;
	  }
	  dolava();
	  while (lavyCierna()){
	  }
	}
    dopredu();
  }
  dopredu();
  wait(200);
  stop();
}

int main(void)
{

    int naraz;
	naraz=1;
	io_init();
   


	set_leds(0x01);
	wait(100);
	set_leds(0x02);
	wait(100);
	set_leds(0x04);
	wait(100);
	set_leds(0x08);
	wait(100);
	set_leds(0x00);

	get_sbot_number();
	stdout = &usart1;
	stdin = &usart1;

    ticks_until_stop = TIMER_SERVO_CONTINUOUS_OPERATION;

	printf("SBOT with basic firmware modified for no packets\n");
		
	while(1)
	{
		if(new_packet == 1)	//if we received a new packed ,we should take a look at it. 
		{
			new_packet = 0;
			switch (newchar)
			{
			case 'a': printf("hello\n");
			          break;
            case 's': for (i = 0; i <= 1 ; i++)
			            printf("%d:%d ", i, adc_vals[i]);
                      printf("\n");
					  break;
            case 'b': printf("bumpers: %d %d %d %d\n", bumper_stat(BUMPER_0),
			                                           bumper_stat(BUMPER_1),
													   bumper_stat(BUMPER_2),
													   bumper_stat(BUMPER_3));
                      break;

            case 't': set_servo(1, SERVO_FW);
			          set_servo(3, SERVO_FW);
			          set_servo(6, SERVO_BW);
			          set_servo(4, SERVO_FW);
			          servo_123_on();
			          servo_456_on();
					  break;

            case ' ': servo_123_off();
                      servo_456_off();
					  break;
            case 'o':while (1){ 
			          set_servo(1, SERVO_FW);
			          set_servo(4, SERVO_BW);
					  servo_123_on();
			          servo_456_on();
					  
					  while (naraz){
					    if ((bumper_stat(BUMPER_0)==0) || (bumper_stat(BUMPER_1)==0)){
						  servo_123_off();
                          servo_456_off();
						  naraz=0;
						}
					  }
					  naraz=1;
					  set_servo(1, SERVO_BW);
			          set_servo(4, SERVO_FW);
					  servo_123_on();
			          servo_456_on();
                      wait(300);
					  servo_123_off();
                      servo_456_off(); 

                      set_servo(1, SERVO_FW);
			          set_servo(4, SERVO_FW);
					  servo_123_on();
			          servo_456_on();
					  wait(900);
                     } 
            case 'k': 
			          set_servo(1, SERVO1dopredu); //lave
			          set_servo(4, SERVO4dopredu);  // prave
					  servo_123_on();
   			          servo_456_on();


					  while ((adc_vals[0]<900) || (adc_vals[1]<900)){ 
					  }
					  servo_123_off();
                      servo_456_off();
                      wait (1000);
					  set_servo(1, SERVO1doprava);
			          set_servo(4, SERVO4doprava);
					  servo_123_on();
			          servo_456_on();

					  int pravyChytil = 0;
					  int lavyChytil = 0;
                      
					  while ((pravyChytil==0) && (lavyChytil==0)) {
                        //printf("%d %d %d %d\n", lavyChytil, pravyChytil, adc_vals[0], adc_vals[1]);
						while ((adc_vals[0]<900) && (adc_vals[1]<900)){ 
					      if (adc_vals[0]>900) pravyChytil=1;
					      if (adc_vals[1]>900) lavyChytil=1;
					    }
                      }
					  servo_123_off();
                      servo_456_off();  
					  break;

			case 'h': najdiCiaru(); 
					  najdiZaciatok();
					  drzCiaru();
					  break;

            case 'i': doprava();
			          break;
			case 'j': dolava();
			          break;
            case 'l': dopredu();
			          break;
            case 'x': printf("%d\n",jeNaCiare());
			          break;


            }
		};
		wait(10);

		/*
			INSERT YOUR CODE BELOW
		*/
	}


}


///////////////////////////////////////////////////////////////////////////////

